- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_4)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_5)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_6)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.NodeGroupsListNodes.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/nodeGroups/listNodes#try-it)

Lists nodes in the node group.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`POST https://compute.googleapis.com/compute/beta/projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}/listNodes`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` The name of the zone for this request. |
| `nodeGroup` | `string` Name of the NodeGroup resource whose nodes you want to list. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": [ { "name": string, "status": enum, "nodeType": string, "serverBinding": { "type": enum }, "serverId": string, "disks": [ { "diskType": string, "diskSizeGb": integer, "diskCount": integer } ], "accelerators": [ { "acceleratorType": string, "acceleratorCount": integer } ], "instances": [ string ], "instanceConsumptionData": [ { "instance": string, "consumptionInfo": { "minNodeCpus": integer, "guestCpus": integer, "memoryMb": integer, "localSsdGb": integer } } ], "consumedResources": { "minNodeCpus": integer, "guestCpus": integer, "memoryMb": integer, "localSsdGb": integer }, "totalResources": { "minNodeCpus": integer, "guestCpus": integer, "memoryMb": integer, "localSsdGb": integer }, "cpuOvercommitType": enum, "satisfiesPzs": boolean, "upcomingMaintenance": { "type": enum, "canReschedule": boolean, "windowStartTime": string, "windowEndTime": string, "latestWindowStartTime": string, "maintenanceStatus": enum, "maintenanceOnShutdown": boolean, "maintenanceReasons": [ enum ] } } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. The resource type, which is always `compute.nodeGroupsListNodes` for the list of nodes in the specified node group. |
| `id` | `string` Output only. Unique identifier for the resource; defined by the server. |
| `items[]` | `object` A list of Node resources. |
| `items[].name` | `string` The name of the node. |
| `items[].status` | `enum` |
| `items[].nodeType` | `string` The type of this node. |
| `items[].serverBinding` | `object` Binding properties for the physical server. |
| `items[].serverBinding.type` | `enum` |
| `items[].serverId` | `string` Server ID associated with this node. |
| `items[].disks[]` | `object` Local disk configurations. |
| `items[].disks[].diskType` | `string` Specifies the desired disk type on the node. This disk type must be a local storage type (e.g.: `local-ssd`). Note that for nodeTemplates, this should be the name of the disk type and not its URL. |
| `items[].disks[].diskSizeGb` | `integer` Specifies the size of the disk in base-2 GB. |
| `items[].disks[].diskCount` | `integer` Specifies the number of such disks. |
| `items[].accelerators[]` | `object` Accelerators for this node. |
| `items[].accelerators[].acceleratorType` | `string` Full or partial URL of the accelerator type resource to attach to this instance. For example: `projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100` If you are creating an instance template, specify only the accelerator name. See [GPUs on Compute Engine](https://docs.cloud.google.com/compute/docs/gpus#introduction) for a full list of accelerator types. |
| `items[].accelerators[].acceleratorCount` | `integer` The number of the guest accelerator cards exposed to this instance. |
| `items[].instances[]` | `string` Instances scheduled on this node. |
| `items[].instanceConsumptionData[]` | `object` Output only. Instance data that shows consumed resources on the node. |
| `items[].instanceConsumptionData[].instance` | `string` Output only. Server-defined URL for the instance. |
| `items[].instanceConsumptionData[].consumptionInfo` | `object` Output only. Resources consumed by the instance. |
| `items[].instanceConsumptionData[].consumptionInfo.minNodeCpus` | `integer` Output only. The minimal guaranteed number of virtual CPUs that are reserved. |
| `items[].instanceConsumptionData[].consumptionInfo.guestCpus` | `integer` Output only. The number of virtual CPUs that are available to the instance. |
| `items[].instanceConsumptionData[].consumptionInfo.memoryMb` | `integer` Output only. The amount of physical memory available to the instance, defined in MiB. |
| `items[].instanceConsumptionData[].consumptionInfo.localSsdGb` | `integer` Output only. The amount of local SSD storage available to the instance, defined in GiB. |
| `items[].consumedResources` | `object` Output only. Node resources that are reserved by all instances. |
| `items[].consumedResources.minNodeCpus` | `integer` Output only. The minimal guaranteed number of virtual CPUs that are reserved. |
| `items[].consumedResources.guestCpus` | `integer` Output only. The number of virtual CPUs that are available to the instance. |
| `items[].consumedResources.memoryMb` | `integer` Output only. The amount of physical memory available to the instance, defined in MiB. |
| `items[].consumedResources.localSsdGb` | `integer` Output only. The amount of local SSD storage available to the instance, defined in GiB. |
| `items[].totalResources` | `object` Output only. Total amount of available resources on the node. |
| `items[].totalResources.minNodeCpus` | `integer` Output only. The minimal guaranteed number of virtual CPUs that are reserved. |
| `items[].totalResources.guestCpus` | `integer` Output only. The number of virtual CPUs that are available to the instance. |
| `items[].totalResources.memoryMb` | `integer` Output only. The amount of physical memory available to the instance, defined in MiB. |
| `items[].totalResources.localSsdGb` | `integer` Output only. The amount of local SSD storage available to the instance, defined in GiB. |
| `items[].cpuOvercommitType` | `enum` CPU overcommit. |
| `items[].satisfiesPzs` | `boolean` Output only. Reserved for future use. |
| `items[].upcomingMaintenance` | `object` Output only. The information about an upcoming maintenance event. |
| `items[].upcomingMaintenance.type` | `enum` Defines the type of maintenance. |
| `items[].upcomingMaintenance.canReschedule` | `boolean` Indicates if the maintenance can be customer triggered. |
| `items[].upcomingMaintenance.windowStartTime` | `string` The current start time of the maintenance window. This timestamp value is in RFC3339 text format. |
| `items[].upcomingMaintenance.windowEndTime` | `string` The time by which the maintenance disruption will be completed. This timestamp value is in RFC3339 text format. |
| `items[].upcomingMaintenance.latestWindowStartTime` | `string` The latest time for the planned maintenance window to start. This timestamp value is in RFC3339 text format. |
| `items[].upcomingMaintenance.maintenanceStatus` | `enum` |
| `items[].upcomingMaintenance.maintenanceOnShutdown` | `boolean` Indicates whether the UpcomingMaintenance will be triggered on VM shutdown. |
| `items[].upcomingMaintenance.maintenanceReasons[]` | `enum` The reasons for the maintenance. Only valid for vms. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.nodeGroups.get`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).